/**
 * @file
 * JS bindings for spinint arrows.
 */

(function($){

  Drupal.behaviors.spinint = {
    attach: function (context, settings) {
      settings = Drupal.settings.spinint;

      // Deal with form cache not displaying value properly on form validation
      // fail.
      $('.spinint').each(function(index){
        $input = $(this).parents('.spinint-wrapper').next('input');
        $(this).text($input.val());
      });

      // Handle up-click.
      $('.spinint-up').bind('click', function() {
        $display = $(this).next('span.spinint');
        $input = $(this).parents('.spinint-wrapper').next('input');
        $val = $display.text() / 1.0 + 1;
        if (settings.max && $val > settings.max) {
          if (settings.min) {
            $val = settings.min;
          } else {
            $val = $val - 1;
          }
        }
        $display.text($val);
        $input.val($val).trigger('change');
        return false;
      });
      
      // Handle down-click.
      $('.spinint-down').bind('click', function(){
        $display = $(this).prev('span.spinint');
        $input = $(this).parents('.spinint-wrapper').next('input');
        $val = $display.text() / 1.0 - 1;
        if (settings.min && $val < settings.min) {
          if (settings.max) {
            $val = settings.max;
          } else {
            $val = $val + 1;
          }
        }
        $display.text($val);
        $input.val($val).trigger('change');
        return false;
      });
    }
  };

})(jQuery);
